function i = whichsubtriangle(x,y,p,q)
%
% given the three triangles defined by x,y and the barycenter,
% returns the subtriangle containing (p,q)
%
% 1 -> x(1),x(2),xbar
% 2 -> x(2),x(3),xbar
% 3 -> x(1),x(3),xbar
%
xbar = sum(x)/3;
ybar = sum(y)/3;
% look into x(1),x(2),xbar
v0 = [xbar-x(1);ybar-y(1)]; % C-A
v1 = [x(2)-x(1);y(2)-y(1)]; % B-A
v2 = [p-x(1);q-y(1)]; % P-A
den = (v0'*v0)*(v1'*v1)-(v0'*v1)*(v1'*v0);
u = ((v1'*v1)*(v2'*v0)-(v1'*v0)*(v2'*v1))/den; 
v = ((v0'*v0)*(v2'*v1)-(v0'*v1)*(v2'*v0))/den;
if ((u >= -100*eps) && (v >= -100*eps) && (u+v <= 1+200*eps))
  i = 1;
else
% look into x(2),x(3),xbar
  v0 = [xbar-x(2);ybar-y(2)]; % C-A
  v1 = [x(3)-x(2);y(3)-y(2)]; % B-A
  v2 = [p-x(2);q-y(2)]; % P-A
  den = (v0'*v0)*(v1'*v1)-(v0'*v1)*(v1'*v0);
  u = ((v1'*v1)*(v2'*v0)-(v1'*v0)*(v2'*v1))/den; 
  v = ((v0'*v0)*(v2'*v1)-(v0'*v1)*(v2'*v0))/den;
  if ((u >= -100*eps) && (v >= -100*eps) && (u+v <= 1+200*eps))
    i = 2;
  else
    i = 3;
  end
end